<script>

	import { onMount } from 'svelte';

	export let items = [];
	export let mode  = 'buy';

	let quantities = {};

	function onMessage(data) {

		switch(data.action) {

			case 'set_mode' : {
				mode = data.mode;
				break;
			}

			case 'set_items' : {
				
				items = data.items;

				for(let i=0; i<items.length; i++)
					quantities[items[i].name] = 1;

				quantities = {...quantities};

				break;
			}

			default: break;
		}

	}

	function buy(item) {
		window.parent.postMessage(JSON.stringify({action: 'buy', name: item.name, qty: quantities[item.name]}), '*');
	}

	function sell(item) {
		window.parent.postMessage(JSON.stringify({action: 'sell', name: item.name, qty: quantities[item.name]}), '*');
	}

	onMount(() => {
		window.parent.postMessage(JSON.stringify({action: 'component_mounted'}), '*');
	});

	window.addEventListener('message', e => onMessage(JSON.parse(e.data)));

</script>

<style>

	.items {
		display: flex;
		flex-direction: row;
		flex-wrap: wrap;
		justify-content: center;
		margin: 10px;
	}

	.item {
		display: flex;
		flex-direction: column;
		justify-content: space-evenly;
		align-items: center;
		width: 280px;
		height: 280px;
		margin: 10px;
		user-select: none;
	}

	.item:nth-child(odd) {
		background-color: rgb(58, 58, 58);
	}

	.item:nth-child(even) {
		background-color: rgb(78, 78, 78);
	}

	.qty input {
		text-align: center;
	}

	.btn-close {
		background-color: red;
    color: white;
    border: 1px solid white;
    border-radius: 50%;
    right: 10px;
    top: 10px;
    position: absolute;
    width: 25px;
    height: 25px;
    text-align: center;
	}

</style>

<div class="shop">
	<div class="btn-close" on:click={e => window.parent.postMessage(JSON.stringify({action: 'internal:destroy'}), '*')}>X</div>
	<div class="items">
		{#each items as item}
			<div class="item">
				<div class="label">{item.label}</div>
				<div class="image">
					<img src="http://assets/core-assets/dist/img/items/{item.image}.png" alt={item.label} height="100"/>
				</div>
				<div class="price">{item.price}$</div>
				<!-- <div class="qty"><input type="number" bind:value="{quantities[item.name]}"/></div> -->
				<div class="confirm">
					<button class="confirm-btn" on:click={e => {mode === 'buy' ? buy(item) : sell(item)}}>{mode === 'buy' ? 'Acheter' : 'Vendre'}</button>
				</div>
			</div>
		{/each}
	</div>
</div>
